Command (Apache ZooKeeper - Server 3.7.0 API)
Date: 2021-03-17

org.apache.zookeeper.server.admin

## Interface Command

- All Known Implementing Classes:
    CommandBase, Commands.CnxnStatResetCommand, Commands.ConfCommand, Commands.ConsCommand, Commands.DigestCommand, Commands.DirsCommand, Commands.DumpCommand, Commands.EnvCommand, Commands.GetTraceMaskCommand, Commands.InitialConfigurationCommand, Commands.IsroCommand, Commands.LastSnapshotCommand, Commands.LeaderCommand, Commands.MonitorCommand, Commands.ObserverCnxnStatResetCommand, Commands.RuokCommand, Commands.SetTraceMaskCommand, Commands.SrvrCommand, Commands.StatCommand, Commands.StatResetCommand, Commands.SyncedObserverConsCommand, Commands.SystemPropertiesCommand, Commands.VotingViewCommand, Commands.WatchCommand, Commands.WatchesByPathCommand, Commands.WatchSummaryCommand, Commands.ZabStateCommand

      public interface Command

  Interface implemented by all commands runnable by JettyAdminServer.
  See Also:
    `CommandBase`, `Commands`, `JettyAdminServer`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `getDoc()` A string documenting this command (e.g., what it does, any arguments it takes).
    `Set<String>` | `getNames()` The set of all names that can be used to refer to this command (e.g., "configuration", "config", and "conf").
    `String` | `getPrimaryName()` The name that is returned with the command response and that appears in the list of all commands.
    `boolean` | `isServerRequired()`
    `CommandResponse` | `run(ZooKeeperServer zkServer, Map<String,String> kwargs)` Run this command.

- - ### Method Detail

    - #### getNames

          Set<String> getNames()

      The set of all names that can be used to refer to this command (e.g., "configuration", "config", and "conf").

    - #### getPrimaryName

          String getPrimaryName()

      The name that is returned with the command response and that appears in the list of all commands. This should be a member of the set returned by getNames().

    - #### getDoc

          String getDoc()

      A string documenting this command (e.g., what it does, any arguments it takes).

    - #### isServerRequired

          boolean isServerRequired()

      Returns:
        true if the command requires an active ZooKeeperServer or a synced peer in order to resolve

    - #### run

          CommandResponse run(ZooKeeperServer zkServer,
                              Map<String,String> kwargs)

      Run this command. Commands take a ZooKeeperServer and String-valued keyword arguments and return a map containing any information constituting the response to the command. Commands are responsible for parsing keyword arguments and performing any error handling if necessary. Errors should be reported by setting the "error" entry of the returned map with an appropriate message rather than throwing an exception.
      Parameters:
        `zkServer` -
        `kwargs` - keyword -> argument value mapping
      Returns:
        Map representing response to command containing at minimum: - "command" key containing the command's primary name - "error" key containing a String error message or null if no error

Copyright © 2008–2021 The Apache Software Foundation. All rights reserved.